"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
exports.MolModel = void 0;
var tslib_1 = require("tslib");
var structure_1 = require("../../mol-model/structure/structure/structure");
var parser_1 = require("../../mol-io/reader/mol/parser");
var mol_1 = require("../../mol-model-formats/structure/mol");
var utils_1 = require("../utils");
exports.MolModel = {
    parse: function (data) {
        return (0, tslib_1.__awaiter)(this, void 0, void 0, function () {
            var parsed, model;
            return (0, tslib_1.__generator)(this, function (_a) {
                switch (_a.label) {
                    case 0:
                        if (!data.trim())
                            return [2 /*return*/, [(0, utils_1.createEmptyStructure)()]];
                        return [4 /*yield*/, (0, parser_1.parseMol)(data).run()];
                    case 1:
                        parsed = _a.sent();
                        if (parsed.isError)
                            throw parsed;
                        return [4 /*yield*/, (0, mol_1.trajectoryFromMol)(parsed.result).run()];
                    case 2:
                        model = _a.sent();
                        return [2 /*return*/, [structure_1.Structure.ofModel(model.representative)]];
                }
            });
        });
    }
};
//# sourceMappingURL=mol.js.map