"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
exports.XtcModel = void 0;
var tslib_1 = require("tslib");
var parser_1 = require("../../mol-io/reader/xtc/parser");
var xtc_1 = require("../../mol-model-formats/structure/xtc");
exports.XtcModel = {
    parse: function (data) {
        return (0, tslib_1.__awaiter)(this, void 0, void 0, function () {
            return (0, tslib_1.__generator)(this, function (_a) {
                return [2 /*return*/, new Promise(function (resolve) {
                        var reader = new FileReader();
                        reader.onload = function (event) {
                            return (0, tslib_1.__awaiter)(this, void 0, void 0, function () {
                                var unitArray, parsed, coordinates;
                                return (0, tslib_1.__generator)(this, function (_a) {
                                    switch (_a.label) {
                                        case 0:
                                            unitArray = new Uint8Array(reader.result);
                                            return [4 /*yield*/, (0, parser_1.parseXtc)(unitArray).run()];
                                        case 1:
                                            parsed = _a.sent();
                                            if (parsed.isError)
                                                throw new Error(parsed.message);
                                            return [4 /*yield*/, (0, xtc_1.coordinatesFromXtc)(parsed.result).run()];
                                        case 2:
                                            coordinates = _a.sent();
                                            resolve(coordinates);
                                            return [2 /*return*/];
                                    }
                                });
                            });
                        };
                        reader.readAsArrayBuffer(data);
                    })];
            });
        });
    }
};
//# sourceMappingURL=xtc.js.map