"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
exports.MappingLineRepr = void 0;
var tslib_1 = require("tslib");
var interaction_line_1 = require("../../../mol-repr/shape/loci/interaction-line");
var utils_1 = require("../../utils");
exports.MappingLineRepr = {
    parse: function (items, plugin) {
        return items.map(function (item) {
            var cell = plugin.managers.cell.get(item.ref);
            var structure = (0, utils_1.getStructureByCell)(cell);
            return (0, utils_1.getLoci)(structure, item.elementIds);
        });
    },
    create: function (locis, 
    // item: CellItem,
    ctx, theme) {
        return (0, tslib_1.__awaiter)(this, void 0, void 0, function () {
            var repr;
            return (0, tslib_1.__generator)(this, function (_a) {
                switch (_a.label) {
                    case 0:
                        repr = (0, interaction_line_1.InteractionLineRepresentation)(ctx, function () { return interaction_line_1.InteractionLineParams; });
                        return [4 /*yield*/, repr
                                .createOrUpdate({}, {
                                pairs: [{ loci: locis }]
                            })
                                .run()];
                    case 1:
                        _a.sent();
                        return [2 /*return*/, repr];
                }
            });
        });
    },
    update: function (representation, locis, ctx, theme) {
        return (0, tslib_1.__awaiter)(this, void 0, void 0, function () {
            return (0, tslib_1.__generator)(this, function (_a) {
                switch (_a.label) {
                    case 0: return [4 /*yield*/, representation.createOrUpdate({}, {
                            pairs: [{ loci: locis }]
                        }).run()];
                    case 1:
                        _a.sent();
                        return [2 /*return*/];
                }
            });
        });
    }
};
//# sourceMappingURL=mapping-line.js.map