"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
exports.timeSlicing = void 0;
window.requestIdleCallback =
    window.requestIdleCallback ||
        function (cb) {
            var start = Date.now();
            return setTimeout(function () {
                cb({
                    didTimeout: false,
                    timeRemaining: function () {
                        return Math.max(0, 50 - (Date.now() - start));
                    }
                });
            }, 1);
        };
function timeSlicing(task, remain) {
    // @ts-ignore
    window.requestIdleCallback(function (deadline) {
        var next = task.next();
        while (!next.done) {
            if (deadline.timeRemaining() <= (remain !== null && remain !== void 0 ? remain : 0)) {
                timeSlicing(task, remain);
                return;
            }
            next = task.next();
        }
    });
}
exports.timeSlicing = timeSlicing;
//# sourceMappingURL=time-slicing.js.map