/**
 * Copyright (c) 2018-2022 mol* contributors, licensed under MIT, See LICENSE file for more info.
 *
 * @author David Sehnal <david.sehnal@gmail.com>
 * @author Alexander Rose <alexander.rose@weirdbyte.de>
 * @author Aliaksei Chareshneu <chareshneu.tech@gmail.com>
 */
import { PluginContext } from '../../mol-plugin/context';
import { StateObjectSelector } from '../../mol-state';
import { PluginStateObject } from '../objects';
export declare const VolumeFormatCategory = "Volume";
declare type Params = {
    entryId?: string;
};
declare function defaultVisuals(plugin: PluginContext, data: {
    volume: StateObjectSelector<PluginStateObject.Volume.Data>;
}): Promise<StateObjectSelector<PluginStateObject.Volume.Representation3D, import("../../mol-state/transformer").StateTransformer<import("../../mol-state/object").StateObject<any, import("../../mol-state/object").StateObject.Type<any>>, import("../../mol-state/object").StateObject<any, import("../../mol-state/object").StateObject.Type<any>>, any>>[]>;
export declare const Ccp4Provider: {
    label: string;
    description: string;
    category: string;
    binaryExtensions: string[];
    parse: (plugin: PluginContext, data: import("../../mol-state").StateObjectRef<PluginStateObject.Data.String | PluginStateObject.Data.Binary>, params?: Params | undefined) => Promise<{
        format: StateObjectSelector<PluginStateObject.Format.Ccp4, import("../../mol-state/transformer").StateTransformer<PluginStateObject.Data.Binary, PluginStateObject.Format.Ccp4, import("../../mol-util/param-definition").ParamDefinition.Normalize<{}>>>;
        volume: StateObjectSelector<PluginStateObject.Volume.Data, import("../../mol-state/transformer").StateTransformer<PluginStateObject.Format.Ccp4, PluginStateObject.Volume.Data, import("../../mol-util/param-definition").ParamDefinition.Normalize<{
            voxelSize: import("../../mol-math/linear-algebra/3d/vec3").Vec3;
            offset: import("../../mol-math/linear-algebra/3d/vec3").Vec3;
            entryId: string;
        }>>>;
    }>;
    visuals: typeof defaultVisuals;
};
export declare const BuiltInVolumeFormats: readonly [readonly ["ccp4", {
    label: string;
    description: string;
    category: string;
    binaryExtensions: string[];
    parse: (plugin: PluginContext, data: import("../../mol-state").StateObjectRef<PluginStateObject.Data.String | PluginStateObject.Data.Binary>, params?: Params | undefined) => Promise<{
        format: StateObjectSelector<PluginStateObject.Format.Ccp4, import("../../mol-state/transformer").StateTransformer<PluginStateObject.Data.Binary, PluginStateObject.Format.Ccp4, import("../../mol-util/param-definition").ParamDefinition.Normalize<{}>>>;
        volume: StateObjectSelector<PluginStateObject.Volume.Data, import("../../mol-state/transformer").StateTransformer<PluginStateObject.Format.Ccp4, PluginStateObject.Volume.Data, import("../../mol-util/param-definition").ParamDefinition.Normalize<{
            voxelSize: import("../../mol-math/linear-algebra/3d/vec3").Vec3;
            offset: import("../../mol-math/linear-algebra/3d/vec3").Vec3;
            entryId: string;
        }>>>;
    }>;
    visuals: typeof defaultVisuals;
}]];
export declare type BuildInVolumeFormat = (typeof BuiltInVolumeFormats)[number][0];
export {};
