/**
 * Copyright (c) 2018-2020 mol* contributors, licensed under MIT, See LICENSE file for more info.
 *
 * @author David Sehnal <david.sehnal@gmail.com>
 * @author Alexander Rose <alexander.rose@weirdbyte.de>
 */
import { Vec3 } from '../../mol-math/linear-algebra';
import { ParamDefinition as PD } from '../../mol-util/param-definition';
import { PluginStateObject as SO } from '../objects';
export { VolumeFromCcp4 };
export { VolumeFromCube };
export { AssignColorVolume };
export { VolumeFromDensityServerCif };
declare type VolumeFromCcp4 = typeof VolumeFromCcp4;
declare const VolumeFromCcp4: import("../../mol-state/transformer").StateTransformer<SO.Format.Ccp4, SO.Volume.Data, PD.Normalize<{
    voxelSize: Vec3;
    offset: Vec3;
    entryId: string;
}>>;
declare type VolumeFromCube = typeof VolumeFromCube;
declare const VolumeFromCube: import("../../mol-state/transformer").StateTransformer<SO.Format.Cube, SO.Volume.Data, PD.Normalize<{
    dataIndex: number;
    entryId: string;
}>>;
declare type VolumeFromDensityServerCif = typeof VolumeFromDensityServerCif;
declare const VolumeFromDensityServerCif: import("../../mol-state/transformer").StateTransformer<SO.Format.Cif, SO.Volume.Data, PD.Normalize<{
    blockHeader: string | undefined;
    entryId: string;
}>>;
declare type AssignColorVolume = typeof AssignColorVolume;
declare const AssignColorVolume: import("../../mol-state/transformer").StateTransformer<SO.Volume.Data, SO.Volume.Data, PD.Normalize<{
    ref: string;
}>>;
