/**
 * Copyright (c) 2019 mol* contributors, licensed under MIT, See LICENSE file for more info.
 *
 * @author Alexander Rose <alexander.rose@weirdbyte.de>
 */
import { Unit, ElementIndex } from '../../mol-model/structure';
import type { SizeTheme } from '../size';
import { ParamDefinition as PD } from '../../mol-util/param-definition';
import { ThemeDataContext } from '../../mol-theme/theme';
export declare const AquasiteSizeThemeParams: {
    hydrogenSize: PD.Numeric;
    oxygenSize: PD.Numeric;
    baseSize: PD.Numeric;
};
export declare type AquasiteSizeThemeParams = typeof AquasiteSizeThemeParams;
export declare function getAquasiteSizeThemeParams(ctx: ThemeDataContext): {
    hydrogenSize: PD.Numeric;
    oxygenSize: PD.Numeric;
    baseSize: PD.Numeric;
};
export declare function getAquasite(unit: Unit, element: ElementIndex, props: PD.Values<AquasiteSizeThemeParams>): number;
export declare function AquasiteSizeTheme(ctx: ThemeDataContext, props: PD.Values<AquasiteSizeThemeParams>): SizeTheme<AquasiteSizeThemeParams>;
export declare const AquasiteSizeThemeProvider: SizeTheme.Provider<AquasiteSizeThemeParams, 'aquasite'>;
